__doc__="""
Usage: mergekdiff [-h]
                  -i <file>
                  -b <branched file>
                  -c <common file>
                  [-m <merged file>]

Does a merge of <file> and <branched file> using <common file> as the common
ancestor.

If an output file is given, the merged file is written to <merged file>

"""
import getopt,os,sys,win32api,re
import win32api,win32con

ExeName="kdiff3.exe"

###############################################################################
def Main (argv):


  try:
    Options,Args=getopt.getopt(argv[1:],"i:b:m:c:h")
  except getopt.error, Message:
    print Message
    print "%s" %__doc__
    sys.exit(1)

  if len(Args)!=0:
    print __doc__
    sys.exit(1)

  FileToMerge=None
  BranchedFile=None
  CommonFile=None
  MergedFile=None

  for Option in Options:
    if Option[0]=='-h':
      print __doc__
      sys.exit(1)
    elif Option[0]=='-i':
      FileToMerge=os.path.abspath(Option[1])
    elif Option[0]=='-b':
      BranchedFile=os.path.abspath(Option[1])
    elif Option[0]=='-m':
      MergedFile=os.path.abspath(Option[1])
    elif Option[0]=='-c':
      CommonFile=os.path.abspath(Option[1])

  if not CommonFile or not FileToMerge or not BranchedFile:
    print __doc__
    sys.exit(1)

  import tempfile
  TempFileName=tempfile.mktemp()
  os.system(r'%s "%s" "%s" "%s" -o "%s"'%(ExeName,CommonFile,BranchedFile,FileToMerge,TempFileName))

  if os.path.exists(TempFileName):
    if os.path.exists(MergedFile):
      os.remove(MergedFile)
    os.rename(TempFileName,MergedFile)

###############################################################################

if __name__ == '__main__':
  __file__=os.path.abspath(sys.argv[0])
  Main(sys.argv)


