from win32con import *
from pywin.mfc import dialog
import win32api,os

RunDir=os.path.split(__file__)[0]

def Select(Diffs,Title,Key):
  global Selected

  IDC_LIST=1000
  IDOK=1
  IDCANCEL=2

  Width=330

  IDD_MAINWINDOW = [ [Title,(0,0,Width,46),DS_NOIDLEMSG|DS_3DLOOK|WS_MINIMIZEBOX|WS_MAXIMIZEBOX|WS_POPUP|WS_VISIBLE|WS_CAPTION|WS_SYSMENU,WS_EX_CLIENTEDGE|WS_EX_APPWINDOW,(12,"Tahoma")], ]
  IDD_MAINWINDOW.append(["ListBox","",IDC_LIST,(0,0,Width,18),LBS_NOINTEGRALHEIGHT|LBS_SORT|LBS_USETABSTOPS|WS_VSCROLL|WS_TABSTOP|WS_VISIBLE|WS_BORDER])
  IDD_MAINWINDOW.append(["STATIC","Press enter to run the selected program\r\nIf you do not want to show this window and run the latest selection:\r\nEdit HKEY_CURRENT_USER\SOFTWARE\Tigris.org\Subversion\Config\Helpers\skip-%s-select"%Key,-1,(5,19,Width,27),WS_VISIBLE])

  hKey=win32api.RegOpenKey(HKEY_CURRENT_USER,r'SOFTWARE\Tigris.org\Subversion\Config\Helpers',0,KEY_READ|KEY_WRITE)

  try:
    SkipSelect=win32api.RegQueryValueEx(hKey,"skip-%s-select"%Key)[0]
  except:
    win32api.RegSetValueEx(hKey,"skip-%s-select"%Key,0,REG_DWORD,0)
    SkipSelect=0

  try:
    Selected=win32api.RegQueryValueEx(hKey,"%s-select"%Key)[0]
  except:
    Selected=0

  class SelectDialog(dialog.Dialog):
    def OnInitDialog(self):
      self.ListBox=self.GetDlgItem(IDC_LIST)
      for Diff in Diffs:
        self.ListBox.AddString(Diff)

      self.ListBox.SetCurSel(Selected)

    def OnOK(self):
      global Selected
      Selected=self.ListBox.GetCurSel()
      win32api.RegSetValueEx(hKey,"%s-select"%Key,0,REG_DWORD,Selected)
      dialog.Dialog.OnOK(self)

  if not SkipSelect:
    Dlg=SelectDialog(IDD_MAINWINDOW)
    if IDOK==Dlg.DoModal():
      return Diffs[Selected]
    else:
      return None
  else:
    return Diffs[Selected]

